/*
* Welcome to your app's main JavaScript file!
*
* We recommend including the built version of this JavaScript file
* (and its CSS file) in your base layout (base.html.twig).
*/

// any CSS you import will output into a single css file (app.css in this case)

// start the Stimulus application
//import './bootstrap';

import 'tui-calendar';

var Calendar = require('tui-calendar'); /* CommonJS */


$(function () {
  var calendar = new Calendar('#calendar', {
    defaultView: 'week',
    taskView: false,
    useCreationPopup: true,
    useDetailPopup: true
  });

  var scheduleIds = []
  var currentSchedule = 1

  function sendCalendarData() {
    console.log(scheduleIds)
    var schedules = []
    scheduleIds.forEach(function(id){
      var schedule = calendar.getSchedule(String(id), '1');
      schedules[schedules.length] = schedule
    })

    console.log(schedules)

    $.ajax({
      type: "POST",
      url: "/calendar/send",
      data: JSON.stringify(schedules),
      success: function (data) { console.log(data) },
      dataType: "json",
      contentType: 'application/json'
    });
  }

  calendar.on('beforeCreateSchedule', function (event) {
    var scheduleData = event
    // var calendarId = '1';
    var schedule = {
      id: String(currentSchedule),
      calendarId: '1',
      title: scheduleData.title,
      isAllDay: scheduleData.isAllDay,
      start: scheduleData.start,
      end: scheduleData.end,
      category: scheduleData.isAllDay ? 'allday' : 'time',
      dueDateClass: '',
      color: calendar.color,
      bgColor: calendar.bgColor,
      dragBgColor: calendar.bgColor,
      borderColor: calendar.borderColor,
      location: scheduleData.location,
      isPrivate: scheduleData.isPrivate,
      state: scheduleData.state
    };

    scheduleIds[scheduleIds.length] = currentSchedule;
    currentSchedule++;

    calendar.createSchedules([schedule]);

    sendCalendarData();
  });

  prevBtn.addEventListener("click", e => {
    calendar.prev();
  });
  nextBtn.addEventListener("click", e => {
    calendar.next();
    sendCalendarData();
  });


  $.ajax({
    type: "POST",
    url: "/calendar/receive",
    success: function (data) {
      var cleanedData = []
      data.forEach(function(schedule){
        if (schedule) {
          schedule.start = schedule.start._date
          schedule.end = schedule.end._date
          scheduleIds[scheduleIds.length] = parseInt(schedule.id)
          currentSchedule++
          cleanedData[cleanedData.length] = schedule
        }
      })

      // console.log(currentSchedule)

      calendar.createSchedules(cleanedData)

     },
  });
});
